<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_PUBLIC_GLOBAL")) return;
define("_INC_PUBLIC_GLOBAL", "1");


function inclure_subpage($fond, $delais_inclus, $contexte_inclus, $cache_incluant)
  {
    // ce perdant de PHP ne comprend pas f(x)[y]
    $page = inclure_page($fond, $delais_inclus, $contexte_inclus, $cache_incluant);
    return $page['texte']; 
  }

function inclure_page($fond, $delais_inclus, $contexte_inclus, $cache_incluant='')
  {
    global $delais;
    static $pile_delais = '', $ptr_delais = 0;
    $ptr_delais++;
    $pile_delais[$ptr_delais] = $delais_inclus;

    spip_log("Inclusion ($cache_incluant)");
    $cle = nom_du_cache($fond, $contexte_inclus);
    $page = ramener_cache($cle,
			  'cherche_page_incluse',
			  array('fond' => $fond, 
				'cache_incluant' => $cache_incluant,
				'contexte' => $contexte_inclus),
			  &$pile_delais[$ptr_delais]);
    
   // si son dlai est + court que l'incluant, il prdomine
   if ($ptr_delais == 1)
     { if ($delais > $pile_delais[$ptr_delais])
	 $delais = $pile_delais[$ptr_delais]; }
   else
     { 
       if ($pile_delais[$ptr_delais-1] > $pile_delais[$ptr_delais])
	 $pile_delais[$ptr_delais-1] = $pile_delais[$ptr_delais];
     }
    $ptr_delais--;
    return $page;
  }

function admin_page($texte, $cached)
{
 // Le bouton des administrateurs est affich par une fonction JavaScript
 // non mise en cache car dpendant de l'utilisateur (pas d'affichage parfois)
 // Elle est appele par le code d'un squelette utilisant FORMULAIRE_ADMIN
 //  mais seulement si flag_preserver n'est pas Vrai,
     
  if  ($GLOBALS['HTTP_COOKIE_VARS']['spip_admin'] &&  !$flag_preserver)
    {
      include_local('inc-admin.php3');
      return (envoi_script(
			   "var bouton_admin = \"" .
			   addslashes(str_replace("\n", ' ', 
				afficher_boutons_admin($cached ? ' *' : ''))) .
			   "\";" .
			   "function admin() 
 {document.write(bouton_admin); document.close(); bouton_admin='';}") .
	      $texte);
    }
  else return $texte;
}

function nom_du_cache($fond, $contexte)
 {
   // Tenir compte de l'URL, pour le jour o on mutualisera Spip 
   $appel = $GLOBALS['PHP_SELF'];
   $appel = substr($appel,0, strrpos($appel, '/')+1) . $fond;
   // Virer les variables internes. 
   // Faudrait rationnaliser pour ne pas interfrer avec contexte_inclus
   if ($contexte)
     while(list($k, $v) = each($contexte))
       {if (!(ereg('((var_*)|recalcul)', $k)))
	   $appel .= "=$v";
       }
   return $appel;
 }

function envoi_script($code)
{
  return
  "<script type='text/javascript' language='JavaScript'><!--
  $code
--></script>\n";
}

?>
