<?php

function calculer_include($fichier, $params, $id_boucle, $boucles, $pi)
{
	global $dossier_squelettes;
	# marche maintenant que le compilateur est parfaitement rentrant 
	if (!$pi && (preg_match("/\s*<.php\s*.fond\s*=\s*[\"\']([^;]*)[\"\']\s*;\s*.delais\s*=\s*([^;]*);\s*include\s*..inc-public.php3?..;\s*.>/",
implode('',file((($dossier_squelettes) &&
					    @file_exists("$dossier_squelettes/$fichier")) ?
					   "$dossier_squelettes/$fichier" :
					   $fichier)),
				$m)))
	    {
	      $l  = "";
	      if ($params) {
		reset($params);
		while (list(, $param) = each($params)) {
		  if (ereg("^([_0-9a-zA-Z]+)[[:space:]]*(=[[:space:]]*([^}]+))?$", $param, $args)) {
		    $var = $args[1];
		    $val = $args[3];
		    $l .= "'$var' =>" .
		      ($val ?
		       ("'" . addslashes($val) . "'") :
		       (index_pile($id_boucle, $var, &$boucles))) .
		      ",";
		  }
		}
	      }

	      return "inclure_subpage('" . $m[1] . "'," . $m[2] . 
		", array(" . $l . '), $Cache["cache"])';}
	  else
	    { # vieux code du compilateur non rentrant. 
	      # reste utile pour les squelettes appels bizarrement
	      $l  = "";
	      if ($params) {
		reset($params);
		while (list(, $param) = each($params)) {
		  if (ereg("^([_0-9a-zA-Z]+)[[:space:]]*(=[[:space:]]*([^}]+))?$", $param, $args)) {
		    $var = $args[1];
		    $val = $args[3];
		    if ($val)
		      $l[] = "'\'$var\' => " . addslashes($val) . "'";
		    else
		      $l[] = "'\'$var\' => \'' . addslashes(" . index_pile($id_boucle, $var, &$boucles) . ") .'\''";
		  }
		}
	      }
	      return "\n'<".
		"?php include_ecrire(\'inc_lang.php3\'); lang_select(lire_meta(\'langue_site\')); \$contexte_inclus = array(' ." . 
		($l ? (join(".', '.\n",$l)) : '""') . ".');" .
		(($dossier_squelettes) ?
		 ("
			if (@file_exists(\'$dossier_squelettes/$fichier\')){
				include(\'$dossier_squelettes/$fichier\');
			} else {
				include(\'$fichier\');
			} " ) :
		 ("include(\'$fichier\');")) .
		"lang_dselect(); ?" . ">'";
	    }
}

// Convertit un texte Spip en une EXPRESSION php 
// donc qqch qui peut tre l'argument d'un Return 
// ou la partie droite d'une affectation

function calculer_texte($texte, $id_boucle, $boucles, $id_mere)
{
	$code = ".\n '".ereg_replace("([\\\\'])", "\\\\1", $texte)."'";

	//
	// Reperer les balises de traduction <:toto:>
	//
	while (eregi("(<:(([a-z0-9_]+):)?([a-z0-9_]+)(\|[^>]*)?:>)", $code, $match)) {
		//
		// Traiter la balise de traduction multilingue
		//
		$chaine = strtolower($match[4]);
 		if (!($module = $match[3]))
		  // ordre des modules a explorer
		  $module = 'local/public/spip';
		// il faudrait traiter un $m non vide
		list ($c,$m) = applique_filtres(explode('|',
							substr($match[5],1)),
						"_T('$module:$chaine')",
						$id_boucle, 
						$boucles,
						$id_mere);
		$code = str_replace($match[1], "'.$c.'", $code);
	}

	return (ereg('^\..', $code) ? substr($code,2) : $code);
}


// gnre l'application d'une liste de filtres

function applique_filtres ($fonctions, $code, $id_boucle, $boucles, $id_mere)
{
  $milieu = '';
  if ($fonctions) {
    while (list(, $fonc) = each($fonctions)) {
      if ($fonc) {
	$arglist = '';
	if (ereg('([^\{\}]*)\{(.+)\}$', $fonc, $regs)) {
	  $fonc = $regs[1];
	  $args = $regs[2];
	  while (ereg('([^,]+),?(.*)$', $args, $regs)) {
	    $args = $regs[2];
	    $arg = trim($regs[1]);
	    if ($arg)
	      {
		if (substr($arg,0,1) =='#')
		  {
		    list($arg,$m) = calculer_champ(array(),substr($arg,1),$id_boucle, $boucles, $id_mere);
		    $milieu .= $m;
		  }
		$arglist .= ','.$arg;
	      }
	  }
	}
	if (function_exists($fonc))
	  $code = "$fonc($code$arglist)";
	else
	  $code = "'"._T('erreur_filtre', array('filtre' => $fonc))."'";
	}
    }
  }
  return array($code,$milieu);
}

?>
